MEMBER()

    PRAGMA('link(Dnsapi.lib)');

    MAP
        MODULE('Dnsapi')
            DnsQuery_A(|
                LONG, | ! lpszName
                SHORT, | ! wType
                SHORT, | ! options
                LONG, | ! lpExtra
                LONG, | ! lpResults
                LONG | ! lpReserved
            ),LONG,PASCAL,NAME('DnsQuery_A')
            DnsRecordListFree(LONG p,LONG t),PASCAL,NAME('DnsRecordListFree')
            memcpy(LONG lpDestination,LONG lpSource,LONG dwLen),LONG,PROC,NAME('_memcpy')
            strcpy(LONG destination,LONG Source),NAME('_strcpy')
        END
    END

    INCLUDE('Win32_DNS.inc'),ONCE

Win32DNS.CONSTRUCT PROCEDURE()
    CODE
        
Win32DNS.DESTRUCT PROCEDURE()
    CODE

Win32DNS.LookUp PROCEDURE(STRING host, SHORT type)!,STRING
searchName CSTRING(128),AUTO
dwResult LONG,AUTO
dwReturn LONG
lpData LONG
    CODE
        CLEAR(Win32DNSRecord);
        searchName = LEFT(CLIP(host));

        CASE DnsQuery_A(ADDRESS(searchName), type, 0, 0, ADDRESS(lpData), 0)
            !-- Successful call to DnsQuery_A
            OF 0
                IF lpData
                    !-- Copy the data to the Win32DNSRecord structure
                    memcpy(ADDRESS(Win32DNSRecord), lpData, SIZE(Win32DNSRecord));

                    !-- lpszNameExchange points to an Mail Exchange Server ..
                    strcpy(Address(searchName), Win32DNSRecord.lpszNameExchange);

                    !-- Free the memory allocated by DnsQuery_A
                    DnsRecordListFree(lpData, 0);

                    !-- Return the IP address
                    RETURN searchName;
                END
            OF 9003
                !-- Host not found
                RETURN 'ERROR: Host not found';
        END

        RETURN 'ERROR: Unknown error';

Win32DNS.LookUpA PROCEDURE(STRING host)!,STRING
    CODE
        RETURN self.Lookup(host, Win32DNSRecordType:A);

Win32DNS.LookUpAAAA PROCEDURE(STRING host)!,STRING
    CODE
        RETURN self.Lookup(host, Win32DNSRecordType:AAAA);

Win32DNS.LookUpMX PROCEDURE(STRING host)!,STRING
    CODE
        RETURN self.Lookup(host, Win32DNSRecordType:MX);
